      t = 0: REM test
      ja = 0: REM 0: input path and constant-value-registers
              REM 1: path = shorten.bin r6=#$00 r7=#$ff
              REM 2: path = nlq-hd.bin  r6=#$00 r7=#$ff

 
      CLS
      PRINT : PRINT
      PRINT "                             SHORTEN.BAS"
      PRINT : PRINT
      PRINT "This program tries to help you to shorten an AVR-assembler-program."
      PRINT "Type 'RUN' at the AVR-Sudio -> the *.HEX-file is generated."
      PRINT "Convert the *.HEX-file to a *.BIN-file with HEX2BIN.EXE from www.atmel.com."
      PRINT "Start this QBasic-program."
      PRINT "(Type ALT&RETURN to maximize the QBasic-window.)"
      PRINT "Input the path and the filename of the *.BIN-file."
      PRINT "It displays places where the AVR-sourcecode could perhaps be shortened."
      PRINT "You must find the correct position at the AVR-code searching in the"
      PRINT " 'project-window' under 'output' -> '*.map'."
      PRINT : PRINT
      PRINT "Dieses Programm versucht Ihnen beim Krzen eines AVR-Assembler-Programms zu"
      PRINT " helfen. "; ""
      PRINT "Geben Sie 'RUN' in AVR-Studio ein -> die *.HEX-Datei wird erzeugt."
      PRINT "Konvertieren Sie die *.HEX-Datei zu einer *.BIN-Datei mit HEX2BIN.EXE von"
      PRINT " www.atmel.com."
      PRINT "Starten Sie dieses QBasic-Programm."
      PRINT "(Drcken Sie ALT&RETURN um das QBasic-Fenster zu maximieren.)"
      PRINT "Geben Sie den Pfad und den Dateinamen der *.BIN-Datei ein."
      PRINT "Es zeigt Stellen an, wo der AVR-Quellcode eventuell gekrzt werden kann."
      PRINT "Sie mssen die korrekte Position im AVR-code finden indem Sie im"
      PRINT " 'project-window' unter 'output' -> '*.map' suchen."
      PRINT : PRINT
      PRINT "Jochen Adler, Haeldestr. 9, D-74912 Kirchardt, Germany"
      PRINT "NLQ@gmx.de, http://www.nlq.de"
      PRINT : PRINT
      PRINT "e = end"
      INPUT a$: IF a$ = "e" THEN END
                                        
      CLS
     
      DIM r(31), v(31): REM register, value of constant-value-register
      FOR i = 0 TO 31: r(i) = 80: NEXT
     
      IF ja = 1 THEN na$ = "c:\avr-code\shorten\shorten.bin": r(0) = 6: v(0) = 0: r(1) = 7: v(1) = 255: GOTO l050
      IF ja = 2 THEN na$ = "c:\avr-code\nlq-hd\nlq-hd.bin": r(0) = 6: v(0) = 0: r(1) = 7: v(1) = 255: GOTO l050
         
      PRINT : PRINT "Path and filename of the *.BIN-file, e.g.:"
      PRINT "Pfad und Dateiname der *.BIN-Datei, z.B.:"
      PRINT "c:\pathpfad\filedatei.bin"
      INPUT na$

      PRINT : PRINT
      PRINT "Do you use a register/registers which has/have always the same value (Y/N)?"
      PRINT "Benutzen Sie (ein) Register, das/die immer den gleichen Wert hat/haben (J/N)?"
l010: a$ = "":  a$ = INKEY$: IF a$ = "n" THEN GOTO l090
      IF (a$ <> "y") AND (a$ <> "j") THEN GOTO l010

      i = 0
     
l020: PRINT : PRINT "Register which has always the same value (0-31, E = end)"
      PRINT "Register, das immer den gleichen Wert hat (0-31, E = Ende)"
      INPUT a$: a = VAL(a$)
      IF a$ = "e" THEN GOTO l050
      IF LEFT$(a$, 1) = "0" THEN GOTO l030
      IF a = 0 THEN GOTO l020

l030: IF (a < 0) OR (a > 31) THEN PRINT : PRINT "Error Fehler": GOTO l020
      r(i) = a
      IF t > 0 THEN PRINT "i, r(i)"; i; r(i)

      PRINT : PRINT "Constant value of this register (0-255)"
      PRINT "Konstanter Wert dieses Registers (0-255)"
      INPUT a$: a = VAL(a$)
      IF LEFT$(a$, 1) = "0" THEN GOTO l040
      IF a = 0 THEN GOTO l020

l040: IF (a < 0) OR (a > 255) THEN PRINT : PRINT "Error Fehler": GOTO l020
      v(i) = a
      IF t > 0 THEN PRINT "i, v(i)"; i; v(i)
      i = i + 1: GOTO l020

l050: i = 0
      PRINT
      PRINT "Register      value"
      PRINT "Register      Wert"

l060: IF r(i) > 79 THEN GOTO l090

      PRINT r(i), v(i)
      i = i + 1: GOTO l060

l090: hd$ = "0123456789abcdef"

      i$ = " ": REM 1 char long input$

      OPEN na$ FOR BINARY AS #2
      pc = 0: REM program-counter


l100: GOSUB l900: REM read 1 word (2 bytes)-----------------------------------

l200: IF (n0 <> 9) OR ((n1 AND 12) <> 0) OR (n3 <> 0) THEN GOTO l300
         REM b.i.not lds/sts

      REM--------------------------------------------------(2 words) lds / sts
      IF t > 0 THEN PRINT : PRINT : PRINT "2-words-command"
      GOSUB l900: REM overread second word
      GOTO l100: REM----------------------------------------------------------
     
l300: IF n0 <> 3 THEN GOTO l400
         REM b.i. not cpi
     
      REM------------------------------------------------------------------cpi
      cc = 0: REM counter constant-registers

l310: IF r(cc) > 79 THEN GOTO l500
         REM b.i. no (more) constant register
     
      k = n1 * 16 + n3
      d = n2 + 16
      IF t > 0 THEN PRINT "cpi r"; RIGHT$(STR$(d), 2); ",$"; MID$(hd$, n1 + 1, 1); MID$(hd$, n3 + 1, 1)
      IF k <> v(cc) THEN cc = cc + 1: GOTO l310
         REM b.i.not cpi r..,$xx
     
      REM -------------------------------------------------------cpi r..,$xx--
      GOSUB l900
      IF (n0 <> 15) OR ((n1 AND 12) <> 0) OR ((n3 AND 7) <> 1) THEN GOTO l200
         REM b.i.not breq
    
      REM-----------------------------------------------cpi r..,$xx | breq----
      k = (n1 AND 3) * 32 + n2 * 2 + (n3 AND 8) / 8
      IF t > 0 THEN PRINT "k: "; k
     
      GOSUB l900
      IF (n0 = 9) AND ((n1 AND 12) = 0) AND (n3 = 0) THEN GOTO l320
         REM b.i. lds/sts
     
      IF (n0 = 9) AND ((n1 AND 14) = 4) AND ((n3 AND 12) = 12) THEN GOTO l320
         REM b.i. jmp/call
    
      REM----------------------------cpi r..,$xx | breq | 1-word-command------
      IF k > 1 THEN pc = pc - 2: GOTO l100
         REM b.i. branch is more than 1 1-word-command

      GOTO l330
         REM = branch is 1 1-word-command

l320: REM----------------------------cpi r..,$xx | breq | 2-word-command------
      IF k > 2 THEN pc = pc - 2: GOTO l100
         REM b.i. branch is more than 1 2-words-command

         REM = branch is 1 2-words-command
     
l330: REM------------------------------cpi r..,$xx | breq over 1 command------
      PRINT : PRINT "programcounter: "; pc - 3; : h = pc - 3: GOSUB l810
      PRINT "cpi r"; RIGHT$(STR$(d), 2); ",$"; MID$(hd$, INT(v(cc) / 16) + 1, 1); MID$(hd$, (v(cc) AND 15) + 1, 1)
      PRINT "breq over 1 command"
      PRINT "-> cpse r"; RIGHT$(STR$(d), 2); ",r"; RIGHT$(STR$(r(cc)), LEN(STR$(r(cc))) - 1); " ???"

      a$ = "": INPUT a$: IF a$ = "e" THEN END
      pc = pc - 1: GOTO l100: REM---------------------------------------------

l400: IF ((n0 <> 1) OR ((n1 AND 12) <> 4)) THEN GOTO l500
         REM b.i.not cp r..,r..
     
      REM-----------------------------------------------------------cp r..,r..
      cc = 0: REM counter constant-registers

l410: IF r(cc) > 79 THEN GOTO l100
         REM b.i. no (more) constant register
     
      d = (n1 AND 1) * 16 + n2
      r = (n1 AND 2) * 8 + n3
     
      IF t > 0 THEN PRINT "cp r"; RIGHT$(STR$(d), LEN(STR$(d)) - 1); ",r"; RIGHT$(STR$(r), LEN(STR$(r)) - 1)
      IF r <> r(cc) THEN cc = cc + 1: GOTO l410
         REM b.i.not cp r..,rxx

      REM---------------------------------------------------------cp r..,rxx--
      IF t > 0 THEN PRINT : PRINT "cp r..,rxx"
      GOSUB l900
      IF (n0 <> 15) OR ((n1 AND 12) <> 0) OR ((n3 AND 7) <> 1) THEN GOTO l200
         REM b.i.not breq
   
      REM------------------------------------------------cp r..,rxx | breq----
      k = (n1 AND 3) * 32 + n2 * 2 + (n3 AND 8) / 8
      IF t > 0 THEN PRINT "k: "; k
     
      GOSUB l900
      IF (n0 = 9) AND ((n1 AND 12) = 0) AND (n3 = 0) THEN GOTO l420
         REM b.i. lds/sts
    
      IF (n0 = 9) AND ((n1 AND 14) = 4) AND ((n3 AND 12) = 12) THEN GOTO l420
         REM b.i. jmp/call
   
      REM----------------------------cpi r..,rxx | breq | 1-word-command------
      IF k > 1 THEN pc = pc - 2: GOTO l100
         REM b.i. branch is more than 1 1-word-command

      GOTO l430
         REM = branch is 1 1-word-command

l420: REM----------------------------cpi r..,rxx | breq | 2-word-command------
      IF k > 2 THEN pc = pc - 2: GOTO l100
         REM b.i. branch is more than 1 2-words-command

         REM = branch is 1 2-words-command

l430: REM-------------------------------cp r..,rxx | breq over 1 command------
      PRINT : PRINT "programcounter: "; pc - 3; : h = pc - 3: GOSUB l810
      PRINT "cp r"; RIGHT$(STR$(d), LEN(STR$(d)) - 1); ",r"; RIGHT$(STR$(r(cc)), LEN(STR$(r(cc))) - 1)
      PRINT "breq over 1 command"
      PRINT "-> cpse r"; RIGHT$(STR$(d), LEN(STR$(d)) - 1); ",r"; RIGHT$(STR$(r(cc)), LEN(STR$(r(cc))) - 1); " ???"

      a$ = "": INPUT a$: IF a$ = "e" THEN END
      pc = pc - 1: GOTO l100: REM---------------------------------------------

l500: IF (n0 <> 15) OR ((n1 AND 8) <> 0) THEN GOTO l600
         REM b.i.not branch
        
      REM---------------------------------------------------------------branch
      IF t > 0 THEN PRINT : PRINT "branch"
      k = (n1 AND 3) * 32 + n2 * 2 + (n3 AND 8) / 8
      IF t > 0 THEN PRINT "k: "; k

l510: IF k > 1 THEN GOTO l100
         REM b.i.not overbranch of 1 command

      REM----------------------------------------------branch over 1 command--
      GOSUB l900: REM next command behind branch
      IF n0 <> 12 THEN GOTO l200
         REM b.i.not rjmp

      REM-------------------------------------branch over 1 command | rjmp----
      k = n1 * 256 + n2 * 16 + n3
      IF t > 0 THEN PRINT "rjmp: k:"; k
      IF (k < 4031) AND (k > 63) THEN GOTO l200
        REM b.i. rjump/rcall farer than 63 bytes

      REM-------------------branch over 1 command | rjmp within 63 bytes------
      PRINT : PRINT "programcounter: "; pc - 2; : h = pc - 2: GOSUB l810
      PRINT "branch and rjmp within 64 bytes"
      PRINT "-> branch-opposite without rjmp???"

      a$ = "": INPUT a$: IF a$ = "e" THEN END
      GOTO l200: REM----------------------------------------------------------

l600: IF (n0 <> 9) OR ((n1 AND 14) <> 4) OR ((n3 AND 12) <> 12) THEN GOTO l700
         REM b.i.not jmp/call

      REM-------------------------------------------------------------jmp/call
      IF t > 0 THEN PRINT : PRINT "jmp/call"
      k = (n1 AND 1) * 20971520 + n2 * 131072 + (n3 AND 1) * 65536

      GOSUB l900
      k = k + n0 * 4096 + n1 * 256 + n2 * 16 + n3
      IF t > 0 THEN PRINT "k pc k-pc"; k; pc; k - pc
      IF ((k - pc) < -2049) OR ((k - pc) > 2047) THEN pc = pc - 2: GOSUB l900: GOTO l700
         REM b.i. jump/call farer than 2048 bytes
    
      REM------------------------------------------------jmp/call within 2kB--
      PRINT : PRINT "programcounter: "; pc - 2; : h = pc - 2: GOSUB l810
      PRINT "jmp/call within 2048 bytes"
      PRINT "-> rjmp/rcall???"

      a$ = "": INPUT a$: IF a$ = "e" THEN END
      pc = pc - 2: GOSUB l900: GOTO l700: REM---------------------------------
     
l700: s = 2
      IF n0 = 13 THEN GOTO l710
         REM b.i.rcall

      IF (n0 <> 9) OR ((n1 AND 14) <> 4) OR ((n3 AND 14) <> 14) THEN GOTO l790
         REM b.i.not call

         REM = call
      GOSUB l900: REM overread second word of call
      s = 3

l710: REM-----------------------------------------------------------rcall/call
      GOSUB l900
      IF (n0 <> 9) OR (n1 <> 5) OR (n2 <> 0) OR (n3 <> 8) THEN GOTO l200
         REM b.i.not ret

      REM---------------------------------------------------rcall/call | ret--
      PRINT : PRINT "programcounter: "; pc - s; : h = pc - s: GOSUB l810
      PRINT "rcall/call and ret"
      PRINT "-> rjmp/jmp???"

      a$ = "": INPUT a$: IF a$ = "e" THEN END
      GOTO l100: REM----------------------------------------------------------

l790: GOTO l100
REM===========================================================================

l800: h = pc

l810: PRINT " $";
      h0 = INT(h / 4096): PRINT MID$(hd$, h0 + 1, 1);
      h1 = h - h0 * 4096
      h2 = INT(h1 / 256): PRINT MID$(hd$, h2 + 1, 1);
      h3 = h1 - h2 * 256
      h4 = INT(h3 / 16): PRINT MID$(hd$, h4 + 1, 1);
      PRINT MID$(hd$, (h3 AND 15) + 1, 1)
      RETURN
REM===========================================================================

l900: IF EOF(2) <> 0 THEN GOTO l910
     
      GET #2, pc * 2 + 1, i$: i = ASC(i$)
      GET #2, pc * 2 + 2, i$: j = ASC(i$)
    
      pc = pc + 1

      PRINT "-";

      n0 = INT(j / 16)
      n1 = j AND 15
      n2 = INT(i / 16)
      n3 = i AND 15
    
      IF t > 0 THEN PRINT "pc i% j% n0 n1 n2 n3: "; pc; i; j; n0; n1; n2; n3

      a$ = "": a$ = INKEY$: IF a$ = "e" THEN END

      RETURN

l910: CLOSE 2
REM===========================================================================

